#include <stdio.h>

/* Constants */

#define STRLEN 64
#define CSMA "csma"
#define SENDER "sender"
#define MEDIUM "medium"

/* Defaults */

int SIGMA=26;
int LAMBDA=782;
int NSEND=2;

/* Global variables */

char myself[STRLEN];

/* Functions */

void setparam(cp,ac)
char *cp; 
int ac;
{
  if(!strcmp(cp,"SIGMA")) SIGMA=ac;
  else if(!strcmp(cp,"LAMBDA")) LAMBDA=ac;
  else if(!strcmp(cp,"NSEND")) NSEND=ac;
  else {
    fprintf(stdout,"%s: unknown parameter %s\n",myself,cp);
    exit(1);
  }
}

void medium() 
{
  FILE *fpt;
  char file[STRLEN];

  sprintf(file,"%s.tg",MEDIUM);
  fprintf(stdout,"%s: + %s ...\n",myself,file);
  if((fpt=fopen(file,"w"))==NULL) {
    fprintf(stdout,"%s: cannot open file %s\n",myself,file);
    exit(1);
  }
  fprintf(fpt,"#states 3\n");
  fprintf(fpt,"#trans 5\n"); 
  fprintf(fpt,"#clocks 1 M\n");
  fprintf(fpt,"\nstate: 0\n");
  fprintf(fpt,"prop: INIT_M\n");
  fprintf(fpt,"invar: TRUE\n");
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"TRUE => BEGIN; reset{M}; goto 1\n"); 
  fprintf(fpt,"\nstate: 1\n");
  fprintf(fpt,"prop: TRASNM_M\n");
  fprintf(fpt,"invar: TRUE\n");
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"M<%d => BEGIN; reset{M}; goto 2\n",SIGMA); 
  fprintf(fpt,"M>=%d => BUSY; reset{}; goto 1\n",SIGMA); 
  fprintf(fpt,"TRUE => END; reset{M}; goto 0\n",SIGMA); 
  fprintf(fpt,"\nstate: 2\n");
  fprintf(fpt,"prop: CD_M\n");
  fprintf(fpt,"invar: M<=%d\n",SIGMA);
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"M<=%d => CD; reset{M}; goto 0\n",SIGMA); 
  fclose(fpt);
  fprintf(stdout,"%s: + file %s dumped\n",myself,file);
}

void sendi(i) 
int i;
{
  FILE *fpt;
  char file[STRLEN];

  sprintf(file,"%s%d.tg",SENDER,i);
  fprintf(stdout,"%s: + %s ...\n",myself,file);
  if((fpt=fopen(file,"w"))==NULL) {
    fprintf(stdout,"%s: cannot open file %s\n",myself,file);
    exit(1);
  }
  fprintf(fpt,"#states 4\n");
  fprintf(fpt,"#trans 9\n"); 
  fprintf(fpt,"#clocks 1 X%d\n",i);
  fprintf(fpt,"\nstate: 0\n");
  fprintf(fpt,"prop: INIT%d\n",i);
  fprintf(fpt,"invar: TRUE\n");
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"TRUE => SEND%d; reset{X%d}; goto 1\n",i,i); 
  fprintf(fpt,"TRUE => CD; reset{}; goto 0\n",i); 
  fprintf(fpt,"\nstate: 1\n");
  fprintf(fpt,"prop: SEND%d\n",i);
  fprintf(fpt,"invar: X%d=0\n");
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"X%d=0 => BEGIN_%d; reset{X%d}; goto 2\n",i,i,i);
  fprintf(fpt,"X%d=0 => BUSY_%d; reset{X%d}; goto 3\n",i,i,i);
  fprintf(fpt,"X%d=0 => CD; reset{X%d}; goto 3\n",i,i,i);
  fprintf(fpt,"\nstate: 2\n");
  fprintf(fpt,"prop: TRANSM%d\n",i);
  fprintf(fpt,"invar: X%d<=%d\n",i,LAMBDA);
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"X%d<=%d => CD; reset{X%d}; goto 3\n",i,LAMBDA,i,i);
  fprintf(fpt,"X%d=%d => END_%d; reset{X%d}; goto 0\n",i,LAMBDA,i,i);
  fprintf(fpt,"\nstate: 3\n");
  fprintf(fpt,"prop: CD%d\n",i);
  fprintf(fpt,"invar: X%d<=%d\n",i,2*SIGMA);
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"X%d<=%d => CD; reset{}; goto 3\n",i,2*SIGMA,i,i);
  fprintf(fpt,"X%d<=%d => TAU%d; reset{X%d}; goto 1\n",i,2*SIGMA,i,i);
  fclose(fpt);
}

void sender() 
{
  char file[STRLEN], line[STRLEN];
  int i;

  if(NSEND<1) {
    fprintf(stdout,"%s: NSEND must be greater than 0\n",myself);
    exit(1);
  }
  sprintf(file,"%s.tg",SENDER);
  sprintf(line,"/bin/rm -f %s*.tg\n",SENDER);
  system(line);
  for(i=1;i<=NSEND;i++) sendi(i);
  if(NSEND==1) {
    sprintf(line,"mv %d1.tg %s\n",SENDER,file);
    system(line);
    }
  else {
    sprintf(line,"ptg %s*.tg \n",SENDER);
    system(line);
    sprintf(line,"/bin/rm -f %s*.tg\n",SENDER);
    system(line);
    sprintf(line,"mv _out.tg %s\n",file);
    system(line);
  }
  for(i=1;i<=NSEND;i++) {
    sprintf(line,"sed -e s/_%d//g %s > /tmp/%s\n",i,file,file);
    system(line);
    sprintf(line,"mv /tmp/%s %s\n",file,file);
    system(line);
  }
  fprintf(stdout,"%s: + file %s dumped\n",myself,file);
}

void csma()
{
  sender();
  medium();
}

main(argc,argv)
int argc;
char *argv[];
{
  int i, j;
  char cp[STRLEN], line[STRLEN], file[STRLEN];

  strcpy(myself,argv[0]);
  fprintf(stdout,"%s: replacing parameters ...\n",myself);
  for(i=1;i<argc;i++) {
    j=0;
    while(argv[i][j]!='=') {
      cp[j]=argv[i][j];
      j++;
    }
    cp[j]='\0';
    setparam(cp,atoi(argv[i]+(j+1)));
  }
  csma();
  sprintf(line,"ptg %s.tg %s.tg \n",SENDER,MEDIUM); 
  system(line);
  sprintf(line,"/bin/rm -f %s.tg %s.tg \n",SENDER,MEDIUM);
  system(line);
  sprintf(file,"%s.tg",CSMA);
  sprintf(line,"mv _out.tg %s\n",file);
  system(line);
  fprintf(stdout,"%s: file %s dumped\n",myself,file);
  fprintf(stdout,"%s: done\n",myself);
}
