#include <stdio.h>

/* Constants */

#define STRLEN 64
#define SERVICE "service"

/* Defaults */

int PI=100;
int ALPHA=49;
int TMIN=50;
int TMAX=80;
int NCELL=1;

/* Global variables */

char myself[STRLEN];

/* Functions */

void setparam(cp,ac)
char *cp; 
int ac;
{
  if(!strcmp(cp,"PI")) PI=ac;
  else if(!strcmp(cp,"ALPHA")) ALPHA=ac;
  else if(!strcmp(cp,"TMIN")) TMIN=ac;
  else if(!strcmp(cp,"TMAX")) TMAX=ac;
  else if(!strcmp(cp,"NCELL")) NCELL=ac;
  else {
    fprintf(stdout,"%s: unknown parameter %s\n",myself,cp);
    exit(1);
  }
}

void isochro() 
{
  FILE *fpt;
  char file[STRLEN];

  fprintf(stdout,"%s: + %s.tg ...\n",myself,"isochro");
  strcpy(file,"isochro.tg");
  if((fpt=fopen(file,"w"))==NULL) {
    fprintf(stdout,"%s: cannot open file %s\n",myself,file);
    exit(1);
  }
  fprintf(fpt,"#states 2\n");
  fprintf(fpt,"#trans 3\n"); 
  fprintf(fpt,"#clocks 1 P\n");
  fprintf(fpt,"\nstate: 0\n");
  fprintf(fpt,"invar: P<=%d\n",PI);
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"P=0 => SS_SAP; reset{P}; goto 1\n"); 
  fprintf(fpt,"P=%d => PERIOD; reset{P}; goto 0\n",PI); 
  fprintf(fpt,"\nstate: 1\n");
  fprintf(fpt,"prop: I_AFTER_SS_SAP\n");
  fprintf(fpt,"invar: P<=%d\n",PI);
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"P=%d => PERIOD; reset{P}; goto 0\n",PI); 
  fclose(fpt);
}

void spacing() 
{
  FILE *fpt;
  char file[STRLEN];

  fprintf(stdout,"%s: + %s.tg ...\n",myself,"spacing");
  strcpy(file,"spacing.tg");
  if((fpt=fopen(file,"w"))==NULL) {
    fprintf(stdout,"%s: cannot open file %s\n",myself,file);
    exit(1);
  }
  fprintf(fpt,"#states 2\n");
  fprintf(fpt,"#trans 2\n"); 
  fprintf(fpt,"#clocks 1 A\n");
  fprintf(fpt,"\nstate: 0\n");
  fprintf(fpt,"invar: TRUE\n");
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"TRUE => DELIVER; reset{A}; goto 1\n"); 
  fprintf(fpt,"\nstate: 1\n");
  fprintf(fpt,"invar: A<=%d\n",ALPHA);
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"A=%d => SPACING; reset{A}; goto 0\n",ALPHA); 
  fclose(fpt);
}

void transmd_i(i) 
int i;
{
  FILE *fpt;
  char file[STRLEN];

  sprintf(file,"transmd%d.tg",i);
  fprintf(stdout,"%s: + %s ...\n",myself,file);
  if((fpt=fopen(file,"w"))==NULL) {
    fprintf(stdout,"%s: cannot open file %s\n",myself,file);
    exit(1);
  }
  fprintf(fpt,"#states 3\n");
  fprintf(fpt,"#trans 3\n"); 
  fprintf(fpt,"#clocks 1 T%d\n",i);
  fprintf(fpt,"\nstate: 0\n");
  fprintf(fpt,"invar: TRUE\n");
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"TRUE => SS_SAP_%d; reset{T%d}; goto 1\n",i,i); 
  fprintf(fpt,"\nstate: 1\n");
  fprintf(fpt,"prop: T_AFTER_SS_SAP\n");
  fprintf(fpt,"invar: T%d<=%d\n",i,TMAX);
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"T%d>=%d => TRANSMD_%d; reset{T%d}; goto 2\n",i,TMIN,i,i); 
  fprintf(fpt,"\nstate: 2\n");
  fprintf(fpt,"invar: TRUE\n");
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"TRUE => DELIVER_%d; reset{T%d}; goto 0\n",i,i); 
  fclose(fpt);
}

void transmd() 
{
  char file[STRLEN], line[STRLEN];
  int i;

  if(NCELL<1) {
    fprintf(stdout,"%s: NCELL must be greater than 0\n",myself);
    exit(1);
  }
  strcpy(file,"transmd.tg");
  sprintf(line,"/bin/rm -f %s\n",file);
  system(line);
  for(i=1;i<=NCELL;i++) transmd_i(i);
  if(NCELL==1) {
    sprintf(line,"mv transmd1.tg %s\n",file);
    system(line);
    }
  else {
    sprintf(line,"kronos transmd*.tg\n");
    system(line);
    sprintf(line,"/bin/rm -f transmd*.tg\n");
    system(line);
    sprintf(line,"mv _out.tg %s\n",file);
    system(line);
  }
  for(i=1;i<=NCELL;i++) {
    sprintf(line,"sed -e s/_%d//g %s > /tmp/%s\n",i,file,file);
    system(line);
    sprintf(line,"mv /tmp/%s %s\n",file,file);
    system(line);
  }
  fprintf(stdout,"%s: + file %s dumped\n",myself,file);
}

void immacpt() 
{
  FILE *fpt;
  char file[STRLEN];

  fprintf(stdout,"%s: + %s.tg ...\n",myself,"immacpt");
  strcpy(file,"immacpt.tg");
  if((fpt=fopen(file,"w"))==NULL) {
    fprintf(stdout,"%s: cannot open file %s\n",myself,file);
    exit(1);
  }
  fprintf(fpt,"#states 2\n");
  fprintf(fpt,"#trans 3\n"); 
  fprintf(fpt,"#clocks 1 I\n");
  fprintf(fpt,"\nstate: 0\n");
  fprintf(fpt,"invar: TRUE\n");
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"TRUE => DELIVER; reset{I}; goto 1\n"); 
  fprintf(fpt,"\nstate: 1\n");
  fprintf(fpt,"invar: TRUE\n");
  fprintf(fpt,"trans:\n");
  fprintf(fpt,"I=0 => SR_SAP; reset{I}; goto 0\n"); 
  fprintf(fpt,"TRUE => DELIVER; reset{I}; goto 1\n"); 
  fclose(fpt);
}

void service()
{
  isochro();
  spacing();
  transmd();
  immacpt();
}

main(argc,argv)
int argc;
char *argv[];
{
  int i, j;
  char cp[STRLEN], line[STRLEN], file[STRLEN];

  strcpy(myself,argv[0]);
  fprintf(stdout,"%s: replacing parameters ...\n",myself);
  for(i=1;i<argc;i++) {
    j=0;
    while(argv[i][j]!='=') {
      cp[j]=argv[i][j];
      j++;
    }
    cp[j]='\0';
    setparam(cp,atoi(argv[i]+(j+1)));
  }
  service();
  sprintf(line,"kronos isochro.tg spacing.tg transmd.tg immacpt.tg\n");
  system(line);
  sprintf(line,"/bin/rm -f isochro.tg spacing.tg transmd.tg immacpt.tg\n");
  system(line);
  sprintf(file,"%s.tg",SERVICE);
  sprintf(line,"mv _out.tg %s\n",file);
  system(line);
  fprintf(stdout,"%s: file %s dumped\n",myself,file);
  fprintf(stdout,"%s: done\n",myself);
}
